import java.awt.*;
import java.awt.event.*;
import com.sun.java.swing.*;

/**
   Creates a simple demonstration of drawing custom graphics 
   on a lightweight component.
*/
class SwingPaintDemo2 extends JPanel
{
  /**
     Paints (renders) a string on the component. 

     @param g the Graphics context in which the painting 
     is done.
  */
  public void paintComponent(Graphics g)
  {
    super.paintComponent(g);
    g.setFont(new Font("sansserif", Font.PLAIN, 16));
    g.drawString("A simple string of text", 60, 145);
  }


  /**
     Specifies the preferred size of this component.

     @return the component's preferred screen size.
  */
  public Dimension getPreferredSize()
  {
    return new Dimension(300, 300);
  }

  
  public static void main(String [] args)
  {
    SwingPaintDemo2 app = new SwingPaintDemo2();
    JFrame f = new JFrame("Swing Graphics Demo");
    WindowListener wl = new WindowAdapter()
      {
	public void windowClosing(WindowEvent e)
	  {
	    e.getWindow().dispose();
	    System.exit(0);
	  }
      };
    f.addWindowListener(wl);

    f.getContentPane().add(app);
    f.pack();
    f.setVisible(true);
  }
}
