import java.awt.Checkbox;
import java.awt.CheckboxGroup;
import java.awt.Font;
import java.awt.Frame;
import java.awt.GridLayout;
import java.awt.Panel;

/*
  A class that demonstrates the different possible states of
  the AWT Checkbox class.  This program also demonstrates
  the CheckboxGroup class.
*/
public class Checkboxes extends Panel
{
  /**
     No-arg constructor.  Builds the complete visible GUI 
     before it returns.  
  */
  public Checkboxes()
  {
    setLayout(new GridLayout(2, 3));
    Font f18 = new Font("SansSerif", Font.PLAIN, 18);
    Font f14 = new Font("SansSerif", Font.PLAIN, 14);

    Checkbox c1 = new Checkbox("Checkbox 1");

    // Checkbox 2 is disabled so it cannot be checked.
    //
    Checkbox c2 = new Checkbox();
    c2.setLabel("Checkbox 2");
    c2.setEnabled(false);

    Checkbox c3 = new Checkbox("Checkbox 3");

    // Create a CheckboxGroup object to manage the states of 
    // the second row of check boxes.  Only one of checkboxes
    // c4, c5 and c6 can be checked at any given time.
    //
    CheckboxGroup group = new CheckboxGroup();

    Checkbox c4 = new Checkbox("Checkbox 4", group, true);
    Checkbox c5 = new Checkbox("Checkbox 5", group, true);
    Checkbox c6 = new Checkbox("Checkbox 6", group, true);

    // Make the text in the check boxes more readable.
    //
    c1.setFont(f18);
    c2.setFont(f18);
    c3.setFont(f18);
    c4.setFont(f18);
    c5.setFont(f18);
    c6.setFont(f18);

    // Add the checkbox components to the application container.
    // Notice that you do not add the checkboxes c4, c5 and c6 to
    // the CheckboxGroup, which is not a component.  
    //
    add(c1);
    add(c2);
    add(c3);
    add(c4);
    add(c5);
    add(c6);
  }

  public static void main(String [] args)
  {
    Checkboxes app = new Checkboxes();

    Frame f = new Frame("Checkboxes");
    f.add(app);
    f.pack();
    f.setVisible(true);
  }
}
