import java.awt.Choice;
import java.awt.Font;
import java.awt.Frame;
import java.awt.GridLayout;
import java.awt.Label;
import java.awt.Panel;

/**
   A program that creates a panel and demonstrates use of
   the AWT Label class.  Adds labels with various alignments
   to the application container.  No getPreferredSize()
   method is needed.  The layout manager will call the
   inherited version.  The size of the panel will be at
   least the size required to lay out all of the labels that
   are children of the panel.
*/
public class Labels extends Panel
{
  /**
     No-arg constructor.  
  */
  public Labels()
  {
    Font f18 = new Font("SansSerif", Font.PLAIN, 18);
    Font f14 = new Font("SansSerif", Font.PLAIN, 14);

    // This label's text is aligned to the right edge of its
    // display area.
    //
    Label name = new Label("Name :  ");
    name.setAlignment(Label.RIGHT);
    name.setFont(f14);

    // This label's text is aligned to the left edge of its
    // display area.
    //
    Label nameVal = new Label("Jim Morrison");
    nameVal.setAlignment(Label.LEFT);
    nameVal.setFont(f14);

    Label address = new Label("Address :  ");
    address.setAlignment(Label.RIGHT);
    address.setFont(f14);

    Label addVal = new Label("Cimetiere Pere LaChese");
    addVal.setAlignment(Label.LEFT);
    addVal.setFont(f14);

    Label city = new Label("City/State/Zip :  ");
    city.setAlignment(Label.RIGHT);
    city.setFont(f14);

    Label cityVal = new Label("Paris, France Cedex 01432");
    cityVal.setAlignment(Label.LEFT);
    cityVal.setFont(f14);

    Label phone = new Label("Phone :  ");
    phone.setAlignment(Label.RIGHT);
    phone.setFont(f14);

    Label phoneVal = new Label("213-555-1212");
    phoneVal.setAlignment(Label.LEFT);
    phoneVal.setFont(f14);

    // A nested container.
    //
    Panel p = new Panel();
    p.setLayout(new GridLayout(0, 2));
    p.add(name);
    p.add(nameVal);
    p.add(address);
    p.add(addVal);
    p.add(city);
    p.add(cityVal);
    p.add(phone);
    p.add(phoneVal);

    add(p);
  }

  public static void main(String [] args)
  {
    Labels app = new Labels();

    Frame f = new Frame("Labels");
    f.add(app);
    f.pack();
    f.setVisible(true);
  }
}
