import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/**
   This class demonstrates the use of Swing text areas.  Swing text
   areas can display text in any font, however all text in the text
   area must be rendered in the same font.
*/
class TextAreaDemo extends JPanel
{
  /**
     No-arg constructor.
  */
  public TextAreaDemo()
  {
    Box box = Box.createVerticalBox();

    Dimension dim = new Dimension(100, 60);

    // Create the string that contains the text to be inserted in the
    // text area.
    //
    StringBuffer str = new StringBuffer();
    str.append("Stretch (a bow) to the very full, \n");
    str.append("And you will wish you had stopped in time.  \n");
    str.append("Temper a (sword-edge) to its very sharpest \n");
    str.append("And the edge will not last long.  \n");
    str.append("When gold and jade fill your hall, \n");
    str.append("You will not be able to keep them safe.  \n");
    str.append("To be proud with wealth and honor \n");
    str.append("is to sow the seeds of one's own downfall.  \n");
    str.append("Retire when your work is done, \n");
    str.append("Such is Heaven's way.  \n");

    // Create the first text area with the previously constructed
    // string text. Specify the font for all of this text.
    //
    JTextArea textArea1 = new JTextArea(str.toString(), 6, 25);
    textArea1.setLineWrap(true);
    textArea1.setWrapStyleWord(true);
    textArea1.setFont(new Font("Serif", Font.PLAIN, 18));

    // Create another string to use in initializing a second text
    // area.
    //
    str = new StringBuffer();
    str.append("To yield is to be preserved whole.  \n");
    str.append("To be bent is to become straight.  \n");
    str.append("To be hollow is to be filled.  \n");
    str.append("To be tattered is to be renewed.  \n");
    str.append("To be in want is to possess.  \n");
    str.append("To have plenty is to be confused.  \n");

    // Create a second text area and initialize it with the text
    // string.  Choose a different font.
    //
    JTextArea textArea2 = new JTextArea(str.toString(), 6, 25);
    textArea2.setLineWrap(true);
    textArea2.setWrapStyleWord(true);
    textArea2.setFont(new Font("Serif", Font.ITALIC, 18));

    // Place each text area in a scroll pane so you can scroll its
    // contents.
    //
    JScrollPane sp1 = new JScrollPane(textArea1);
    JScrollPane sp2 = new JScrollPane(textArea2);    

    box.add(sp1);
    box.add(Box.createVerticalStrut(20));
    box.add(new JScrollPane(textArea2));

    add(box);
  }

  public static void main(String [] args)
  {
    TextAreaDemo app = new TextAreaDemo();

    JFrame f = new JFrame("Text Area Demo");
    WindowListener wL = new WindowAdapter()
      {
	public void windowClosing(WindowEvent e)
	  {
	    ((Window) e.getSource()).dispose();
	    System.exit(0);
	  }
      };
    f.addWindowListener(wL);

    f.getContentPane().add(app);
    f.pack();
    f.setVisible(true);
  }
}
