import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/**
   This class demonstrates how to use Swing tool tips.
*/
class ToolTips extends JPanel
{
  /**
     No-arg constructor.
  */
  public ToolTips()
  {
    // Create a button which will have associated tool tip text.
    // Set the tool tip text.
    //
    JButton button1 = new JButton("Do Something");
    button1.setToolTipText("Describes what it means to 'do something'");

    // Do the same for the second button.  Notice that you did not
    // have to create a JToolTip object.  The setToolTipText does it
    // for you!
    //
    JButton button2 = new JButton("Do Nothing");
    button2.setToolTipText("I think this is pretty self-explanatory");

    add(button1);
    add(button2);
  }

  public static void main(String [] args)
  {
    JFrame f = new JFrame("Tool Tips Demo");
    WindowListener wL = new WindowAdapter()
      {
	public void windowClosing(WindowEvent e)
	  {
	    ((Window) e.getSource()).dispose();
	    System.exit(0);
	  }
      };
    f.addWindowListener(wL);

    ToolTips app = new ToolTips();

    f.getContentPane().add(app);
    f.pack();
    f.setVisible(true);
  }
}
