import java.awt.*;
import java.awt.event.*;

import javax.swing.*;
import javax.swing.event.*;


public class ListSelectionEventDemo extends JPanel
{
  public ListSelectionEventDemo()
  {

    String [] listElements = {"Archery", "Badminton", "Cross-Country Skiing",
			      "Diving", "Golf", "Ice Hockey", "Lacrosse", 
			      "Skiing", "Swimming", "Soccer", "Surfing", 
			      "Tennis", "Water polo", 
			      "Yoga"};
			      
    JList list = new JList(listElements);
    list.setFont(new Font("sansserif", Font.PLAIN, 14));
    JScrollPane sp = new JScrollPane(list);

    ListSelectionListener lSL = new ListSelectionMonitor();

    // Add a list selection listener to the list, not to the
    // scroll pane.
    //
    list.addListSelectionListener(lSL);

    add(sp);
  }


  public Dimension getPreferredSize()
  {
    return new Dimension(280, 180);
  }


  public static void main(String [] args)
  {
    ListSelectionEventDemo app = new ListSelectionEventDemo();

    JFrame f = new JFrame("List Selection Event Demo");
    WindowListener wL = new WindowAdapter()
      {
	public void windowClosing(WindowEvent e)
	  {
	    e.getWindow().dispose();
	    System.exit(0);
	  }
      };
    f.addWindowListener(wL);
    
    f.getContentPane().add(app);
    f.pack();
    f.setVisible(true);
  }
}


class ListSelectionMonitor implements ListSelectionListener
{
  public void valueChanged(ListSelectionEvent e)
  {
    if (e.getValueIsAdjusting())
      return;

    System.out.println("First index = " + e.getFirstIndex());
    System.out.println("Last index  = " + e.getLastIndex());
    System.out.println();
  }

}
