import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;

public class MouseEventDemo extends JPanel 
{
  public MouseEventDemo()
  {
    setLayout(new GridLayout(2, 0));

    MouseMonitor mL = new MouseMonitor();
    
    JPanel one = new JPanel();
    one.setBorder(BorderFactory.createLineBorder(Color.red, 1));
    one.addMouseListener(mL);
    one.addMouseMotionListener(mL);

    JLabel l1 = new JLabel("Panel 1");
    one.add(l1);

    JPanel two = new JPanel();
    two.setBorder(BorderFactory.createLineBorder(Color.red, 1));
    two.addMouseListener(mL);
    two.addMouseMotionListener(mL);

    JLabel l2 = new JLabel("Panel 2");
    two.add(l2);
    
    add(one);
    add(two);
  }

  public Dimension getPreferredSize()
  {
    return new Dimension(350, 150);
  }

  public static void main(String [] args)
  {
    MouseEventDemo app = new MouseEventDemo();

    JFrame f = new JFrame("Mouse Event Demo");
    WindowListener wl = new WindowAdapter() 
      {
	public void windowClosing(WindowEvent e) 
	  {
	    ((Window) e.getSource()).dispose();
	    System.exit(0);
	  }
      };
    f.addWindowListener(wl);
    f.getContentPane().add(app);
    f.pack();
    f.setVisible(true);
  }

  JLabel label;
}


class MouseMonitor implements MouseInputListener
{
  public void mouseClicked(MouseEvent e)
  {
    System.out.println("Mouse clicked: num clicks = " + e.getClickCount());
    System.out.println("               location = " + e.getPoint());
  }

  public void mouseEntered(MouseEvent e)
  {
    System.out.println("Mouse entered.");
  }

  public void mouseExited(MouseEvent e)
  {
    System.out.println("Mouse exited.");
  }

  public void mousePressed(MouseEvent e)
  {
    System.out.println("Mouse pressed: location = ");
    System.out.println("               x = " + e.getX());
    System.out.println("               x = " + e.getY());
  }

  public void mouseReleased(MouseEvent e)
  {
    System.out.println("Mouse released: location = " + e.getPoint());

  }

  public void mouseDragged(MouseEvent e)
  {
    System.out.println("Mouse clicked: num clicks = " + e.getClickCount());
  }

  public void mouseMoved(MouseEvent e)
  {
    System.out.println("Mouse moved: location = " + e.getPoint());
  }
}



