import java.awt.*;
import java.awt.event.*;

import javax.swing.*;
import javax.swing.event.*;


public class PopupMenuEventDemo extends JPanel
{
  public PopupMenuEventDemo()
  {
    final JPopupMenu popup = new JPopupMenu("Popup Menu");
    popup.setLabel("Popup Menu");
    popup.add(new JMenuItem("Menu item 1"));
    popup.add(new JMenuItem("Menu item 2"));
    popup.add(new JMenuItem("Menu item 3"));
    popup.addSeparator();
    popup.add(new JMenuItem("Menu item 4"));
    popup.add(new JMenuItem("Menu item 5"));
    popup.add(new JMenuItem("Menu item 6"));

    popup.setInvoker(this);

    PopupMenuListener pL = new PopupMenuMonitor();
    popup.addPopupMenuListener(pL);

    MouseListener mL = new MouseAdapter()
      {
	public void mouseClicked(MouseEvent e)
	  {
	    if (visible)
	      {
		visible = false;
		popup.setVisible(false);
	      }
	    else 
	      {
		visible = true;
		popup.show(PopupMenuEventDemo.this, 60, 25);
	      }
	  }
      };
    addMouseListener(mL);

    add(popup);
  }


  public Dimension getPreferredSize()
  {
    return new Dimension(282, 180);
  }


  public static void main(String [] args)
  {
    PopupMenuEventDemo app = new PopupMenuEventDemo();

    JFrame f = new JFrame("Popup Event Demo");
    WindowListener wL = new WindowAdapter()
      {
	public void windowClosing(WindowEvent e)
	  {
	    e.getWindow().dispose();
	    System.exit(0);
	  }
      };
    f.addWindowListener(wL);
    
    f.getContentPane().add(app);
    f.pack();
    f.setVisible(true);
  }

  boolean visible;
}


class PopupMenuMonitor implements PopupMenuListener
{
  public void popupMenuCanceled(PopupMenuEvent e)
  {
    System.out.println("Popup menu canceled.");
    System.out.println();
  }


  public void popupMenuWillBecomeInvisible(PopupMenuEvent e)
  {
    System.out.println("Popup menu will become invisible.");
    System.out.println();
  }


  public void popupMenuWillBecomeVisible(PopupMenuEvent e)
  {
    System.out.println("Popup menu will become visible.");
    System.out.println();
  }
}



